<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, height=device-height, initial-scale=1, user-scalable=no">
  <meta name="description" content="API docs for the oauthLogin method from the WialonSdk class, for the Dart programming language.">
  <title>oauthLogin method - WialonSdk class - wialon library - Dart API</title>


  
  <link rel="preconnect" href="https://fonts.gstatic.com">
  <link href="https://fonts.googleapis.com/css2?family=Roboto+Mono:ital,wght@0,300;0,400;0,500;0,700;1,400&display=swap" rel="stylesheet">
  <link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">
  
  <link rel="stylesheet" href="../../static-assets/github.css?v1">
  <link rel="stylesheet" href="../../static-assets/styles.css?v1">
  <link rel="icon" href="../../static-assets/favicon.png?v1">

  
</head>


<body data-base-href="../../"
      data-using-base-href="false">

<div id="overlay-under-drawer"></div>

<header id="title">
  <button id="sidenav-left-toggle" type="button">&nbsp;</button>
  <ol class="breadcrumbs gt-separated dark hidden-xs">
    <li><a href="../../index.html">wialon</a></li>
    <li><a href="../../wialon/wialon-library.html">wialon</a></li>
    <li><a href="../../wialon/WialonSdk-class.html">WialonSdk</a></li>
    <li class="self-crumb">oauthLogin method</li>
  </ol>
  <div class="self-name">oauthLogin</div>
  <form class="search navbar-right" role="search">
    <input type="text" id="search-box" autocomplete="off" disabled class="form-control typeahead" placeholder="Loading search...">
  </form>
</header>

<main>


  <div id="dartdoc-main-content" class="main-content">
      <div>
<h1><span class="kind-method">oauthLogin</span> method 
    <a href="https://dart.dev/null-safety" class="feature feature-null-safety" title="Supports the null safety language feature.">Null safety</a>
</h1></div>

    <section class="multi-line-signature">
      

<span class="returntype"><a href="https://api.flutter.dev/flutter/dart-async/Future-class.html">Future</a><span class="signature">&lt;<wbr><span class="type-parameter"><a href="https://api.flutter.dev/flutter/dart-core/String-class.html">String</a>?</span>&gt;</span></span>
<span class="name ">oauthLogin</span>(<wbr><ol class="parameter-list"><li><span class="parameter" id="oauthLogin-param-username">{<span>required</span> <span class="type-annotation"><a href="https://api.flutter.dev/flutter/dart-core/String-class.html">String</a></span> <span class="parameter-name">username</span>, </span></li>
<li><span class="parameter" id="oauthLogin-param-password"><span>required</span> <span class="type-annotation"><a href="https://api.flutter.dev/flutter/dart-core/String-class.html">String</a></span> <span class="parameter-name">password</span>}</span></li>
</ol>)

      

    </section>
    
<section class="desc markdown">
  <p>Login into Wialon using username and password through OAuth, this method will return an Access Token</p>
</section>


    
<section class="summary source-code" id="source">
  <h2><span>Implementation</span></h2>
  <pre class="language-dart"><code class="language-dart">Future&lt;String?&gt; oauthLogin({required String username, required String password}) async {
  String urlToGetSign = &quot;https:&#47;&#47;hosting.wialon.com&#47;login.html?&quot;
      &quot;client_id=$username&quot;
      &quot;&amp;access_type=-1&quot;
      &quot;&amp;activation_time=0&quot;
      &quot;&amp;duration=0&quot;
      &quot;&amp;flags=0x1&quot;;

  Uri uri = Uri.parse(urlToGetSign);
  http.Response response = await http.get(uri);
  Document page = parser.parse(response.body);
  List&lt;Element&gt; elements = page.getElementsByTagName(&quot;input&quot;);

  String? sign;
  for (Element element in elements) {
    if (element.attributes[&quot;name&quot;] == &quot;sign&quot;) {
      sign = element.attributes[&quot;value&quot;];
      break;
    }
  }

  if (sign == null) {
    throw SdkException(message: &quot;Sign not found&quot;);
  }

  Map&lt;String, dynamic&gt; request = {
    &#39;response_type&#39;: &#39;token&#39;,
    &#39;wialon_sdk_url&#39;: &#39;https:&#47;&#47;hst-api.wialon.com&#39;,
    &#39;client_id&#39;: username,
    &#39;access_type&#39;: &#39;-1&#39;,
    &#39;activation_time&#39;: &#39;0&#39;,
    &#39;duration&#39;: &#39;0&#39;,
    &#39;flags&#39;: &#39;7&#39;,
    &#39;login&#39;: username,
    &#39;passw&#39;: password,
    &#39;sign&#39;: sign,
    &#39;redirect_uri&#39;: &#39;https:&#47;&#47;hosting.wialon.com&#47;post_token.html&#39;,
  };

  uri = Uri.parse(&quot;https:&#47;&#47;hosting.wialon.com&#47;oauth.html&quot;);
  response = await http.post(uri, body: request);
  String redirect = response.headers[&#39;location&#39;]!;

  uri = Uri.parse(redirect);
  http.Client client = http.Client();
  http.StreamedResponse response2 = await client.send(http.Request(&quot;GET&quot;, uri)..followRedirects = false);
  String? responseUrl = response2.headers[&#39;location&#39;];
  if (responseUrl == null) {
    throw SdkException(message: &quot;Response url not found&quot;);
  }

  responseUrl = responseUrl.split(&quot;?&quot;).last;
  Map&lt;String, dynamic&gt; responseMap = Uri.splitQueryString(responseUrl);
  String? token = responseMap[&#39;access_token&#39;];
  return token;
}</code></pre>
</section>


  </div> <!-- /.main-content -->

  <div id="dartdoc-sidebar-left" class="sidebar sidebar-offcanvas-left">
    <header id="header-search-sidebar" class="hidden-l">
  <form class="search-sidebar" role="search">
    <input type="text" id="search-sidebar" autocomplete="off" disabled class="form-control typeahead" placeholder="Loading search...">
  </form>
</header>

<ol class="breadcrumbs gt-separated dark hidden-l" id="sidebar-nav">
  <li><a href="../../index.html">wialon</a></li>
  <li><a href="../../wialon/wialon-library.html">wialon</a></li>
  <li><a href="../../wialon/WialonSdk-class.html">WialonSdk</a></li>
  <li class="self-crumb">oauthLogin method</li>
</ol>


    <h5>WialonSdk class</h5>
    <ol>

        <li class="section-title"><a href="../../wialon/WialonSdk-class.html#constructors">Constructors</a></li>
          <li><a href="../../wialon/WialonSdk/WialonSdk.html">WialonSdk</a></li>


    <li class="section-title">
      <a href="../../wialon/WialonSdk-class.html#instance-properties">Properties</a>
    </li>
    <li><a href="../../wialon/WialonSdk/baseUrl.html">baseUrl</a></li>
    <li><a href="../../wialon/WialonSdk/debug.html">debug</a></li>
    <li class="inherited"><a href="https://api.flutter.dev/flutter/dart-core/Object/hashCode.html">hashCode</a></li>
    <li><a href="../../wialon/WialonSdk/host.html">host</a></li>
    <li class="inherited"><a href="https://api.flutter.dev/flutter/dart-core/Object/runtimeType.html">runtimeType</a></li>
    <li><a href="../../wialon/WialonSdk/sessionId.html">sessionId</a></li>

    <li class="section-title"><a href="../../wialon/WialonSdk-class.html#instance-methods">Methods</a></li>
    <li><a href="../../wialon/WialonSdk/call.html">call</a></li>
    <li><a href="../../wialon/WialonSdk/log.html">log</a></li>
    <li><a href="../../wialon/WialonSdk/logout.html">logout</a></li>
    <li class="inherited"><a href="https://api.flutter.dev/flutter/dart-core/Object/noSuchMethod.html">noSuchMethod</a></li>
    <li><a href="../../wialon/WialonSdk/oauthLogin.html">oauthLogin</a></li>
    <li><a href="../../wialon/WialonSdk/reverseGeocoding.html">reverseGeocoding</a></li>
    <li><a href="../../wialon/WialonSdk/tokenLogin.html">tokenLogin</a></li>
    <li class="inherited"><a href="https://api.flutter.dev/flutter/dart-core/Object/toString.html">toString</a></li>

    <li class="section-title inherited"><a href="../../wialon/WialonSdk-class.html#operators">Operators</a></li>
    <li class="inherited"><a href="https://api.flutter.dev/flutter/dart-core/Object/operator_equals.html">operator ==</a></li>




</ol>

  </div><!--/.sidebar-offcanvas-->

  <div id="dartdoc-sidebar-right" class="sidebar sidebar-offcanvas-right">
  </div><!--/.sidebar-offcanvas-->

</main>

<footer>
  <span class="no-break">
    wialon
      2.0.3
  </span>

  
</footer>



<script src="../../static-assets/highlight.pack.js?v1"></script>
<script src="../../static-assets/script.js?v1"></script>



</body>

</html>

